// ---------------------------------------------------------------------
// Author: herbert.reichardt@justmail.de
// Compiler: BC 3.1
// Project Parameters:
// Model Large
// Stack-checking ON
// Based on ODI LFN Tools (c) 1999 Ortwin Glck
// License: Free Software under GPL License
// ----------------------------------------------------------------------
// unicode versions of stringhandling functions

short * Wstrncat(short *dst, const short *src, size_t n)
{
  if (n != 0)
  {
    short *d = dst;
    const short *s = src;

    while (*d != 0)
      d++;
    do {
      if ((*d = *s++) == 0)
	break;
      d++;
    } while (--n != 0);
    *d = 0;
  }
  return dst;
}

short * Wstrncpy(short *dst, const short *src, size_t n)
{
  if (n != 0) {
    short *d = dst;
    const short *s = src;

    do {
      if ((*d++ = *s++) == 0)
      {
	while (--n != 0)
	  *d++ = 0;
	break;
      }
    } while (--n != 0);
  }
  return dst;
}

short * Wstrcat(short *s, const short *append)
{
  short *save = s;

  for (; *s; ++s);
  while ((*s++ = *append++) != 0);
  return save;
}

int Wstrncmp(const short *s1, const short *s2, size_t n)
{

  if (n == 0)
    return 0;
  do {
    if (*s1 != *s2++)
      return *(unsigned const short *)s1 - *(unsigned const short *)--s2;
    if (*s1++ == 0)
      break;
  } while (--n != 0);
  return 0;
}

int Wstrlen(const unsigned short *s)
{
  int i = 0;

  if (s == NULL)
    return 0;

  for (; *s; ++s)
       i++;

  return i;
}

int Wstrcmp(const short *s1, const short *s2)
{
  while (*s1 == *s2)
  {
    if (*s1 == 0)
      return 0;
    s1++;
    s2++;
  }
  return *(unsigned const short *)s1 - *(unsigned const short *)(s2);
}

short * Wstrcpy(short *to, const short *from)
{
  short *save = to;

  for (; (*to = *from) != 0; ++from, ++to);
  return save;
}
